// Copyright 2019 Antrea Authors
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Code generated by client-gen. DO NOT EDIT.

package v1beta1

import (
	"time"

	v1beta1 "github.com/vmware-tanzu/antrea/pkg/apis/networking/v1beta1"
	scheme "github.com/vmware-tanzu/antrea/pkg/client/clientset/versioned/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// AddressGroupsGetter has a method to return a AddressGroupInterface.
// A group's client should implement this interface.
type AddressGroupsGetter interface {
	AddressGroups() AddressGroupInterface
}

// AddressGroupInterface has methods to work with AddressGroup resources.
type AddressGroupInterface interface {
	Get(name string, options v1.GetOptions) (*v1beta1.AddressGroup, error)
	List(opts v1.ListOptions) (*v1beta1.AddressGroupList, error)
	Watch(opts v1.ListOptions) (watch.Interface, error)
	AddressGroupExpansion
}

// addressGroups implements AddressGroupInterface
type addressGroups struct {
	client rest.Interface
}

// newAddressGroups returns a AddressGroups
func newAddressGroups(c *NetworkingV1beta1Client) *addressGroups {
	return &addressGroups{
		client: c.RESTClient(),
	}
}

// Get takes name of the addressGroup, and returns the corresponding addressGroup object, and an error if there is any.
func (c *addressGroups) Get(name string, options v1.GetOptions) (result *v1beta1.AddressGroup, err error) {
	result = &v1beta1.AddressGroup{}
	err = c.client.Get().
		Resource("addressgroups").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do().
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of AddressGroups that match those selectors.
func (c *addressGroups) List(opts v1.ListOptions) (result *v1beta1.AddressGroupList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1beta1.AddressGroupList{}
	err = c.client.Get().
		Resource("addressgroups").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do().
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested addressGroups.
func (c *addressGroups) Watch(opts v1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Resource("addressgroups").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch()
}
